<template>
    <div class="board__projects container">
        <div class="table-head" v-if="!isTablet">
            <span data-sort="none" data-sort-type="text" @click="sortTableByColumn($event, 'title')" class="el-col-12 table-col-head">Задача<i class="table-filter-icon el-icon-sort"></i></span>
            <span data-sort="none" data-sort-type="text" @click="sortTableByColumn($event, 'project')" class="el-col-4 table-col-head">Протокол<i class="table-filter-icon el-icon-sort"></i></span>
            <span data-sort="none" data-sort-type="text" @click="sortTableByColumn($event, 'responsible')" class="el-col-3 el-col-offset-1 table-col-head">Ответственный<i class="table-filter-icon el-icon-sort"></i></span>
            <span data-sort="none" data-sort-type="date" @click="sortTableByColumn($event, 'term')" class="el-col-2 table-col-head">Дата<i class="table-filter-icon el-icon-sort"></i></span>
            <span data-sort="none" data-sort-type="text" @click="sortTableByColumn($event, 'status')" class="el-col-2 table-col-head">Статус<i class="table-filter-icon el-icon-sort"></i></span>
        </div>
        <div class="table-head" v-if="isTablet">
            <span data-sort="none" data-sort-type="text" @click="sortTableByColumn($event, 'title')" class="el-col-16 table-col-head">Задача<i class="table-filter-icon el-icon-sort"></i></span>
            <span data-sort="none" data-sort-type="text" @click="sortTableByColumn($event, 'responsible')" class="el-col-7 el-col-offset-1 table-col-head">Ответственный<i class="table-filter-icon el-icon-sort"></i></span>
        </div>
        <Task v-for="(task, i) of list" :key="i" :task="task"/>
    </div>
</template>

<script>

import Task from "@/components/Board/views/table/Task"
import {EventBus} from "@/main"
import {mapGetters} from "vuex";
export default {
    name: 'BoardViewTable',
    props: {
        list: {
            type: Array,
            required: true,
            default: () => ([])
        }
    },
    computed: {
        ...mapGetters({
            isTablet: ['viewport/isTablet'],
            tasks: ['task/getTasks'],
        }),
    },
    methods: {
        sortTableByColumn(e, column) {
            EventBus.$emit('clearSearch')
            const el = e.currentTarget
            const i = el.getElementsByTagName('i')[0] //иконка фильтра колонки
            const icons = Array.from(document.getElementsByClassName('table-filter-icon')) //DOM список иконок фильтра

            //Обнуление всех иконок фильтра
            icons.forEach(icon => {
                icon.setAttribute('data-sort', 'none')
                icon.className = 'table-filter-icon el-icon-sort'
            })

            if (el.getAttribute('data-sort') === 'none')
                el.setAttribute('data-sort', 'ascending')

            if (el.getAttribute('data-sort') === 'ascending') {
                i.className = 'table-filter-icon el-icon-sort-up'
                el.setAttribute('data-sort', 'descending')
            }
            else if (el.getAttribute('data-sort') === 'descending') {
                i.className = 'table-filter-icon el-icon-sort-down'
                el.setAttribute('data-sort', 'ascending')
            }

            const sortType = el.getAttribute('data-sort-type') //Тип фильтруемого поля: => text | date
            const sortArea = el.getAttribute('data-sort') //Тип сортировки: => none | ascending | descending

            let tasks = [...this.tasks]
            if (sortType === 'text') {
                tasks = tasks.sort((a, b) => {
                    if (a[column] < b[column]) return 1
                    if (a[column] > b[column]) return -1
                }).reverse()
            }
            if (sortType === 'date')
                tasks = tasks.sort((a, b) => new Date(b.term).getTime() - new Date(a.term).getTime())

            //Если фильтр установлен на возрастание, переворачиваем массив
            if (sortArea === 'ascending')
                tasks = tasks.reverse()

            this.$store.commit('task/setTasks', tasks)
        }
    },
    components: {Task}
}
</script>

<style scoped lang="scss">
.table {
    width: 100%;
    @include flex(initial, initial, column);
    &:nth-of-type(5n + 5) {margin-right: 0;}
}
.table-head {
    display: flex;
    padding: .5rem .833rem .5rem .5rem;
    position: sticky;
    top: 0;
    background-color: #F9F9F9;
    z-index: $position-def-index;
}
.table-col-head {
    @include font-size(18);
    color: #8B8E9F;
    font-weight: bold;
    cursor: pointer;
    user-select: none;
    transition: $transition-default;
    &:hover {color: $color-sky}
}
.table-wrapper {
    @include flex(initial, center);
    @extend .path-hover;
    width: max-content;
    cursor: pointer;
    padding: 0 .5rem;
    margin: 0 auto;
}

@media only screen and (max-width: 480px) {
    .project {width: 100%;}
    .table-col-head {@include font-size(16);}
}
</style>

